Bug 504081 - kernel: TPM: get_event_name stack corruption [mrg-1.2]
kernel: TPM: get_event_name stack corruption [mrg-1.2]
Status: CLOSED NOTABUG
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: realtime-kernel (Show other bugs)
1.2
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Real Time Maintenance
David Sommerseth
:
Depends On: 503902
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-04 01:25 EDT by Eugene Teo (Security Response)
Modified: 2016-05-22 19:28 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 503902
Environment:
Last Closed: 2009-09-22 06:46:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Eugene Teo (Security Response) 2009-06-04 01:25:10 EDT
+++ This bug was initially created as a clone of Bug #503902 +++

Description of problem:
get_event_name uses sprintf to fill a buffer declared on the stack.  It fills the buffer 2 bytes at a time.  What the code doesn't take into account is that sprintf(buf, "%02x", data) actually writes 3 bytes.  2 bytes for the data and then it nul terminates the string.  Since we declare buf to be 40 characters long and then we write 40 bytes of data into buf sprintf is going to write 41 characters.  The fix is to leave room in buf for the nul terminator.

Upstream commit:
http://git.kernel.org/linus/fbaa58696cef848de818768783ef185bd3f05158

Note: this is not addressed in 2.6.29.4.
Comment 1 Eugene Teo (Security Response) 2009-09-22 06:46:04 EDT
This is fixed in 2.6.31.

Note You need to log in before you can comment on or make changes to this bug.